"use strict";
/* IMPORT */
const fs = require("fs");
const path = require("path");
/* TINY READDIR */
const readdir = (rootPath, options) => {
    var _a;
    const maxDepth = (_a = options === null || options === void 0 ? void 0 : options.depth) !== null && _a !== void 0 ? _a : Infinity, directories = [], files = [], result = { directories, files };
    const populateResult = async (rootPath, depth = 1) => {
        if (depth > maxDepth)
            return result;
        const dirents = await fs.promises.readdir(rootPath, { withFileTypes: true }).catch(() => { }) || [];
        if (!dirents.length)
            return result;
        await Promise.all(dirents.map((dirent) => {
            const subPath = path.resolve(rootPath, dirent.name);
            if (dirent.isFile()) {
                files.push(subPath);
            }
            else if (dirent.isDirectory()) {
                directories.push(subPath);
                if (depth >= maxDepth)
                    return;
                return populateResult(subPath, depth + 1);
            }
            return;
        }));
        return result;
    };
    return populateResult(rootPath);
};
/* EXPORT */
module.exports = readdir;
module.exports.default = readdir;
Object.defineProperty(module.exports, "__esModule", { value: true });
